unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DropTarget, DropBMPTarget, DropSource, DropBMPSource, StdCtrls,
  ComCtrls, ActiveX, jpeg, Clipbrd, DropMetaTarget, DropMetaSource, Menus,
  DropPictureTarget, DropPictureSource;

var
  CF_JFIF: Word;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    DropDummy1: TDropDummy;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ScrollBox1: TScrollBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    N2: TMenuItem;
    R1: TMenuItem;
    Show1: TMenuItem;
    D1: TMenuItem;
    O1: TMenuItem;
    Test11: TMenuItem;
    Test21: TMenuItem;
    Terst31: TMenuItem;
    Test41: TMenuItem;
    Image1: TImage;
    Test51: TMenuItem;
    DropPictureTarget1: TDropPictureTarget;
    DropBMPSource1: TDropBMPSource;
    DropMetaSource1: TDropMetaSource;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure R1Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure Test11Click(Sender: TObject);
    procedure Test21Click(Sender: TObject);
    procedure Terst31Click(Sender: TObject);
    procedure Test41Click(Sender: TObject);
    procedure Test51Click(Sender: TObject);
    procedure DropPictureTarget1Drop(Sender: TObject;
      ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
  private
    { Private 錾 }
    DragPoint: TPoint;
    function Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
    function Clipboard2Stream(Format: Word; MemStream: TMemoryStream): Boolean;
    procedure GetJPEG; // Nbv{[h JPEG `̃f[^荞ގ葱
  public
    { Public 錾 }
    OrgBitmap: TBitmap;      // ݂̉摜rbg}bvƂĕۑۑ
    procedure MakeOrgBitmap; // ݂̉摜 OrgBitmap ɕۑ葱
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  // DropBMPTarget1.Register(ScrollBox1);
  DropPictureTarget1.Register(ScrollBox1);
  // DropMetaTarget1.Register(StatusBar1);
  DropDummy1.Register(Self);
  OrgBitmap := TBitmap.Create; // ݂̉摜rbg}bvƂĕۑۑ
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  OrgBitmap.Free;
  DropDummy1.UnRegisterAll;
  DropPictureTarget1.UnregisterAll;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  DragPoint := Point(X, Y);
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  DR: TDragResult;
  S: String;
  FT: String;
begin
  if (Shift <> [ssLeft]) or (Image1.Picture.Graphic = Nil) then
    Exit;

  if (Abs(X - DragPoint.X) < Mouse.DragThreshold) and
     (Abs(Y - DragPoint.Y) < Mouse.DragThreshold) then
    Exit;

  S := '';
  FT := '';
  DropPictureTarget1.DragTypes := []; // Disable StatusBar1 target temporarily.
  DropDummy1.DragTypes := []; // Disable Form1 target temporarily.

  if Image1.Picture.Graphic is TMetafile then
  begin
    DropMetaSource1.Metafile.Assign(Image1.Picture.Graphic);
    DR := DropMetaSource1.Execute; // Do it here - dragging from Image1.
    FT := DropMetaSource1.FormatTymed;
  end
  else
  begin
    DropBMPSource1.Bitmap.Assign(OrgBitmap);
    DR := DropBMPSource1.Execute; // Do it here - dragging from Image1.
    FT := DropBMPSource1.FormatTymed;
  end;

  DropDummy1.DragTypes := [dtCopy, dtMove, dtLink]; // Enable Form1 as a drop target again.
  DropPictureTarget1.DragTypes := [dtCopy, dtMove, dtLink]; // Enable Panel1 as a drop target again.

  //Display in StatusBar1 whether the drag was successful or not...
  case DR of
    drDropCopy:  S := 'Copied successfully';
    drDropLink:  S := 'Scrap file created successfully';
    drCancel:    S := 'Drop cancelled';
    drOutMemory: S := 'Can''t drop, out of memory.';
  else
    S := 'Can''t drop - unknown reason.';
  end;
  S := S + '  ===>  ' + FT;
  StatusBar1.SimpleText := S;
end;

procedure TForm1.MakeOrgBitmap; // ݂̉摜 OrgBitmap ɕۑ葱
begin
  if Image1.Picture.Graphic = Nil then
    Exit;
  OrgBitmap.ReleaseHandle;
  if (Image1.Picture.Graphic is TBitmap) or
     (Image1.Picture.Graphic is TJPEGImage)  then
    OrgBitmap.Assign(Image1.Picture.Graphic)
  else
  begin
    OrgBitmap.Width := Image1.Picture.Graphic.Width;
    OrgBitmap.Height := Image1.Picture.Graphic.Height;
    OrgBitmap.Canvas.Draw(0, 0, Image1.Picture.Graphic);
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    Caption := '';
    StatusBar1.SimpleText := '';
    Image1.AutoSize := False;
    Image1.Picture.Graphic := Nil;
    Image1.Picture.LoadFromFile(OpenDialog1.Filename);
    if Image1.Picture.Graphic <> Nil then
    begin
      if Image1.Picture.Graphic is TMetafile then
      begin
        if Image1.Picture.Metafile.Enhanced then
        begin
          Image1.Picture.Metafile.Width := Image1.Picture.Metafile.Width + 1;
          Image1.Picture.Metafile.Height := Image1.Picture.Metafile.Height + 1;
        end;
        Image1.Picture.Metafile.Inch := 0;
      end;
      MakeOrgBitmap; // J摜 OrgBitmap ɕۑB
      Caption := OpenDialog1.Filename;
    end;
    Image1.AutoSize := True;
  end;
end;

procedure TForm1.Save1Click(Sender: TObject);
var
  S: String;
begin
  if Image1.Picture.Graphic = Nil then
    Exit;

  if Caption[1] = ' ' then
  begin
    if Image1.Picture.Graphic is TBitmap then
      S := 'Sample.bmp'
    else if Image1.Picture.Graphic is TJPEGImage then
      S := 'Sample.jpg'
    else if Image1.Picture.Graphic is TMetafile then
      S := 'Sample.emf'
    else if Image1.Picture.Graphic is TIcon then
      S := 'Sample.ico';
  end
  else
    S := ExtractFileName(Caption);

  SaveDialog1.FileName := S;
  if SaveDialog1.Execute then
    Image1.Picture.SaveToFile(SaveDialog1.Filename);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
  if Image1.Picture.Graphic = Nil then
    Exit;
  Clipboard.Assign(Image1.Picture);
end;

procedure TForm1.Paste1Click(Sender: TObject);
var
  S: String;
begin
  if not Clipboard.HasFormat(CF_PICTURE) then
    Exit;

  Caption := '';
  StatusBar1.SimpleText := '';
  S := ' Clipboard has no Image.';
  Image1.AutoSize := False;
  Image1.Picture.Graphic := Nil;

  if Clipboard.HasFormat(CF_JFIF) then
    GetJPEG
  else
    Image1.Picture.Assign(Clipboard);

  if Image1.Picture.Graphic <> Nil then
  begin
    if Image1.Picture.Graphic is TMetafile then
    begin
      if Image1.Picture.Metafile.Enhanced then
      begin
        S := ' EMF Image was copied';
        Image1.Picture.Metafile.Width := Image1.Picture.Metafile.Width + 1;
        Image1.Picture.Metafile.Height := Image1.Picture.Metafile.Height + 1;
      end
      else
        S := ' WMF Image was copied';
      Image1.Picture.Metafile.Inch := 0;
    end
    else if Image1.Picture.Graphic is TBitmap then
      S := ' Bitmap Image was copied'
    else if Image1.Picture.Graphic is TJPEGImage then
      S := ' JPEG Image was copied'
    else if Image1.Picture.Graphic is TIcon then
      S := ' Icon Image was copied'
    else
      S := ' Unknown Image was copied';
    MakeOrgBitmap; // J摜 OrgBitmap ɕۑB
    StatusBar1.SimpleText := S + ' from clipboard.';
    Caption := S + '.';
  end
  else
  begin
    StatusBar1.SimpleText := S;
    Caption := S;
  end;
  Image1.AutoSize := True;
end;

procedure TForm1.R1Click(Sender: TObject);
begin
  Clipboard.Clear;
end;

procedure TForm1.D1Click(Sender: TObject);
var
  S: String;
begin
  S := ' ';
  if Clipboard.HasFormat(CF_BITMAP) then
    S := S + 'CF_BITMAP  ';
  if Clipboard.HasFormat(CF_DIB) then
    S := S + 'CF_DIB  ';
  if Clipboard.HasFormat(CF_ENHMETAFILE) then
    S := S + 'CF_ENHMETAFILE  ';
  if Clipboard.HasFormat(CF_METAFILEPICT) then
    S := S + 'CF_METAFILEPICT  ';
  if Clipboard.HasFormat(CF_JFIF) then
    S := S + 'CF_JFIF  ';
  if Clipboard.HasFormat(CF_OEMTEXT) then
    S := S + 'CF_OEMTEXT  ';
  if Clipboard.HasFormat(CF_TEXT) then
    S := S + 'CF_TEXT  ';
  if Clipboard.HasFormat(CF_UNICODETEXT) then
    S := S + 'CF_UNICODETEXT  ';
  if Clipboard.HasFormat(CF_PALETTE) then
    S := S + 'CF_PALETTE  ';
  if Clipboard.HasFormat(CF_COMPONENT) then
    S := S + 'CF_COMPONENT  ';
  if Clipboard.HasFormat(CF_PICTURE) then
    S := S + 'CF_PICTURE  ';
  if Clipboard.HasFormat(CF_LOCALE) then
    S := S + 'CF_LOCALE  ';
  if S = ' ' then
    S := 'Clipboard has no data.';
  ShowMessage(S);
end;

procedure TForm1.Test11Click(Sender: TObject);
var
  Format : Word;
  Jpg: TJPEGImage;
  Data: THandle;
  Palette: HPALETTE;
begin
  if Image1.Picture.Graphic = Nil then
    Exit;
  Jpg := TJPEGImage.Create;
  try
    Jpg.Assign(OrgBitmap);
    Jpg.SaveToClipBoardFormat(Format, Data, Palette);
    ClipBoard.SetAsHandle(Format,Data);
  finally
    Jpg.Free;
  end;
end;

procedure TForm1.Test21Click(Sender: TObject);
var
  Format : Word;
  Data: THandle;
  Palette: HPALETTE;
begin
  if Image1.Picture.Graphic = Nil then
    Exit;
  Image1.Picture.SaveToClipboardFormat(Format, Data, Palette);
  ClipBoard.SetAsHandle(Format,Data);
end;

procedure TForm1.Terst31Click(Sender: TObject);
var
  Jpg: TJPEGImage;
begin
  if Image1.Picture.Graphic = Nil then
    Exit;
  Jpg := TJPEGImage.Create;
  try
    Jpg.Assign(OrgBitmap);
    Clipboard.Assign(Jpg);
  finally
    Jpg.Free;
  end;
end;

procedure TForm1.Test41Click(Sender: TObject);
begin
  if Image1.Picture.Graphic is TJPEGImage then
    Clipboard.Assign(Image1.Picture.Graphic);
end;

procedure TForm1.Test51Click(Sender: TObject);
var
  Jpg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  Jpg := TJPEGImage.Create;
  try
    Jpg.Assign(OrgBitmap);
    MemStream := TMemoryStream.Create;
    try
      Jpg.SaveToStream(MemStream);
      Stream2Clipboard(CF_JFIF, MemStream);
    finally
      MemStream.Free;
    end;
  finally
    Jpg.Free;
  end;
end;

procedure TForm1.GetJPEG;
var
  Jpg: TJPEGImage;
  MemStream: TMemoryStream;
begin
  Jpg := TJPEGImage.Create;
  try
    MemStream := TMemoryStream.Create;
    try
      Clipboard2Stream(CF_JFIF, MemStream);
      Jpg.LoadFromStream(MemStream);
      Image1.Picture.Assign(Jpg);
    finally
      MemStream.Free;
    end;
  finally
    Jpg.Free;
  end;
end;

function TForm1.Stream2Clipboard(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
begin
  Result := False;
  if MemStream.Size = 0 then
    Exit;
  Data := GlobalAlloc(GMEM_MOVEABLE or GMEM_DDESHARE, MemStream.Size);
  try
    DataPtr := GlobalLock(Data);
    try
      MemStream.Position := 0;
      MemStream.ReadBuffer(DataPtr^, MemStream.Size);
      MemStream.Position := 0;
    finally
      GlobalUnlock(Data);
    end;
    Clipboard.SetAsHandle(Format, Data);
  except
    GlobalFree(Data);
    raise;
  end;
  Result := True;
end;

function TForm1.Clipboard2Stream(Format: Word; MemStream: TMemoryStream): Boolean;
var
  Data: THandle;
  DataPtr: Pointer;
  MSize: Integer;
  MPtr: Pointer; // ꎞǂݍݗpobt@
begin
  Result := False;
  Data := Clipboard.GetAsHandle(Format);
  if Data = 0 then
    Exit;
  DataPtr := GlobalLock(Data);
  if DataPtr = Nil then
    Exit;
  try
    MSize :=  GlobalSize(Data);
    GetMem(MPtr, MSize);
    try
      Move(DataPtr^, MPtr^, MSize); // Uobt@ɓǂݍ
      MemStream.Position := 0;
      MemStream.WriteBuffer(MPtr^, MSize); // 炽߂MemoryStreamɏ
      MemStream.Position := 0;
    finally
      FreeMem(MPtr);
    end;
  finally
    GlobalUnlock(Data);
  end;
  Result := True;
end;

procedure TForm1.DropPictureTarget1Drop(Sender: TObject;
  ShiftState: TShiftState; Point: TPoint; var Effect: Integer);
var
  S: String;
begin
  S := '';
  Image1.AutoSize := False;
  Image1.Picture.Assign(DropPictureTarget1.Picture); // Dragging to Image1
  case Effect of
    DROPEFFECT_NONE:   S := 'DROPEFFECT_NONE';
    DROPEFFECT_COPY:   S := 'DROPEFFECT_COPY';
    DROPEFFECT_MOVE:   S := 'DROPEFFECT_MOVE';
    DROPEFFECT_LINK:   S := 'DROPEFFECT_LINK';
  else
    S := 'Unknown Effect( ' + IntToStr(Effect) + ' )';
  end;
  S := S + '  <===  ' + DropPictureTarget1.FormatTymed;
  StatusBar1.SimpleText := S;

  MakeOrgBitmap; // hbvꂽ摜 OrgBitmap ɕۑB
  if Image1.Picture.Graphic = Nil then
    Caption := ' No Image was dropped.'
  else if Image1.Picture.Graphic is TBitmap then
    Caption := ' Bitmap Image was dropped.'
  else if Image1.Picture.Graphic is TMetafile then
    Caption := ' Metafile Image was dropped.'
  else if Image1.Picture.Graphic is TJPEGImage then
    Caption := ' JPEG Image was dropped.'
  else if Image1.Picture.Graphic is TJPEGImage then
    Caption := ' Some Image was dropped.';
  Image1.AutoSize := True;
end;

initialization
  CF_JFIF := RegisterClipboardFormat('JFIF');
  TPicture.RegisterClipboardFormat(CF_JFIF, TJPEGImage);
  RegisterClass(TJPEGImage);

end.
